<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use \Zeedhi\Framework\Util\Functions;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class CancelamentoServico extends CrudWithParameterBag {
    protected $dataSourceName = '';
    protected $parameterBagColumns = array('NRORG', 'CDFILIAL', 'DATAINI', 'DATAFIN', 'CDLOJA');
    protected $CancelamentoServicoService;
    protected $utilService;

    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag,  Utilities\Util $utilService,  Services\CancelamentoServico $CancelamentoServicoService) {
        parent::__construct($dataSourceManager, $parameterBag);
        $this->utilService = $utilService;
        $this->CancelamentoServicoService = $CancelamentoServicoService;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $result = array();
        ini_set('memory_limit', '500M');
        $conditions = $this->utilService->getParamsAsArray($request);
        
        try {
            $conditions['__is_report'] = ($request->getFilterCriteria()->getPage() === null); 
            
            if(!Functions::arrayKeyExists('CDFILIAL', $conditions)) {
                $conditions['TCDFILIAL'] = 'T';
            } else {
                if(is_array($conditions['CDFILIAL'])) {
                    $conditions['CDFILIAL'] = implode("_", $conditions['CDFILIAL']);
                } else {
                    $conditions['CDFILIAL'] = $conditions['CDFILIAL'];
                }
            }
            
            if(!Functions::arrayKeyExists('CDLOJA', $conditions)) {
                $conditions['TCDLOJA'] = 'T';
            } else {
                if(is_array($conditions['CDLOJA'])) {
                    $conditions['CDLOJA'] = implode("_", $conditions['CDLOJA']);
                } else {
                    $conditions['CDLOJA'] = $conditions['CDLOJA'];
                }
            }
            
            if(!Functions::arrayKeyExists('GARCONFORM', $conditions)) {
                $conditions['TCDVENDEDOR'] = 'T';
            } else {
                if(is_array($conditions['GARCONFORM'])) {
                    $conditions['CDVENDEDOR'] = implode("_", $conditions['GARCONFORM']);
                } else {
                    $conditions['CDVENDEDOR'] = $conditions['GARCONFORM'];
                }
            }
            
            if( array_key_exists('DTENTRVENDA', $conditions) ) {
                $conditions['DATAINI'] = $conditions['DTENTRVENDA'][0];
                $conditions['DATAFIN'] = $conditions['DTENTRVENDA'][1];
                unset($conditions['DTENTRVENDA']);
            }
            
            $result = $this->CancelamentoServicoService->getCancelamentoServico($conditions);
            $response->addDataSet(new DataSet ('vnd55005_relCancelamentoServico', $result));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
}