<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Utilities;

class ManutencaoBeneficioUtilizado extends CrudWithParameterBag {

    protected $dataSourceName = 'manutencaoBeneficioUtilizado';
    protected $parameterBagColumns = array('NRORG', 'CDCLIENTE', 'CDCONSUMIDOR', 'CDCAMPANHA');
    
     public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $utilService, $connection) {
        $this->utilService = $utilService;
        parent::__construct($dataSourceManager, $parameterBag);
        $this->connection = $connection;
        
    }
    
    public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        $data = $request->getDataSet()->getRows();
        $queryLoja = "UPDATE
                        BENEFICIOFOS
                    SET
                        DSOBSMOVBENECONS = :DSOBSMOVBENECONS
                    WHERE
                            (NRORG = :NRORG) 
                        AND (CDCAMPANHA = :CDCAMPANHA )
                        AND (CDCLIENTE = :CDCLIENTE )
                        AND (CDCONSUMIDOR = :CDCONSUMIDOR)
                        AND (NRSEQBENEFICIO = NRSEQBENEFICIO)";
                        
        $stmt = $this->connection->prepare($queryLoja); 
		$stmt->execute(array(
            "NRORG" => $data[0]['NRORG']
		));
    }

    
}

    

